#include "stdafx.h"
#include "Disciplina.h"

Disciplina::Disciplina(int i, int na, char* ac):
ObjLAlunos()
{ 
	id = i;
    pDeptoAssociado		= NULL;  
 
    strcpy (area_conhecimento, ac ); 
}

Disciplina::~Disciplina()
{ 
   pDeptoAssociado  = NULL;
}

void  Disciplina::setId ( int i ) 		
{ 
	id = i; 	
}

int   Disciplina::getId ( )  		
{  
	return id;  	
}

void  Disciplina::setNome(char* n)  	
{  
	strcpy(nome, n);  
}

char* Disciplina::getNome()
{  
	return nome;  
}

void Disciplina::setDepartamento(Departamento* pd)
{
  // Cada vez que um Departamento  associado a uma Disciplina,
  // esta Disciplina passa a fazer parte da lista de disciplina 
  // do Departamento, por meio do comando abaixo.
  pDeptoAssociado = pd;
  pDeptoAssociado->incluaDisciplina ( this );
}

Departamento* Disciplina::getDepartamento ( )
{
  return  pDeptoAssociado;
}


void Disciplina::incluaAluno ( Aluno* pa )
{
	ObjLAlunos.incluaInfo(pa, pa->getNome());
}

void Disciplina::listeAlunos()
{
    ObjLAlunos.listeInfos();
}

void Disciplina::listeAlunos2()
{
    //ObjLAlunos.listeAlunos2();
}
