#include "stdafx.h"
#include "Principal.h"
#include "Windows.h"

// A T E N   O
// A ordem de chamada dos construtores dos objetos (agredados) nesta classe
//  definida pela sua ordem de declarao na classe Principal e NO (estra-
// nhamente) pela sua ordem de chamada aqui (a partir do construtor da Principal).

Principal::Principal ( ):
// "geradores" de identificao
cont_idAluno		(0),
cont_idDisc			(0),
cont_idDepart		(0),
// Contrutores dos objetos da Classe Disciplina
Computacao1_2006	(cont_idDisc++),
Introd_Alg_2007		(cont_idDisc++),
Computacao2_2007	(cont_idDisc++),
Metodos2_2007		(cont_idDisc++),
// Contrutores dos objetos da Classe Aluno
AAA					(cont_idAluno++),
BBB					(cont_idAluno++),
CCC					(cont_idAluno++),
DDD					(cont_idAluno++),
EEE					(cont_idAluno++),
//Contrutores dos Objetos da Classe Departamento
EletronicaUTFPR		(cont_idDepart++),	
MatematicaUTFPR		(cont_idDepart++),
FisicaUTFPR			(cont_idDepart++),
MatematicaPrinceton	(cont_idDepart++),
FisicaPrinceton		(cont_idDepart++),
MatematicaCambridge	(cont_idDepart++),
FisicaCambridge		(cont_idDepart++)
{   
    SYSTEMTIME st;
    GetSystemTime(&st);
    //printf("Year:%d\nMonth:%d\nDate:%d\nHour:%d\nMin:%d\nSecond:% d\n" ,st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);

    diaAtual = st.wMonth;
	mesAtual = st.wDay;
	anoAtual = st.wYear;
    Inicializa ( ); 
	Executar ( ); 

}

void Principal::Inicializa ( )
{   
	InicializaAlunos ( );
    InicializaUnivesidades ( );
    InicializaDepartamentos ( );
    InicializaProfessores ( );
    InicializaDisciplinas ( );
	InicializaEstagiarios ( );
}

void Principal::InicializaAlunos()
{ 
	Pessoa* ponteiroPessoa;
	Aluno*  ponteiroAluno;

	AAA.setNome	("AAA");
	LAlunos.incluaInfo(&AAA, AAA.getNome());	
	ponteiroAluno = &AAA;
	ponteiroPessoa = static_cast<Pessoa*>(ponteiroAluno);
	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());

	BBB.setNome	("BBB");
	LAlunos.incluaInfo(&BBB, BBB.getNome());
	ponteiroAluno = &BBB;
	ponteiroPessoa = static_cast<Pessoa*>(ponteiroAluno);
	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());

	CCC.setNome	("CCC");
	LAlunos.incluaInfo(&CCC, CCC.getNome());
	ponteiroAluno = &CCC;
	ponteiroPessoa = static_cast<Pessoa*>(ponteiroAluno);
	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());

	DDD.setNome	("DDD");
	LAlunos.incluaInfo(&DDD, DDD.getNome());
	ponteiroAluno = &DDD;
	ponteiroPessoa = static_cast<Pessoa*>(ponteiroAluno);
	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());

	EEE.setNome	("EEE");
	LAlunos.incluaInfo(&EEE, EEE.getNome());
	ponteiroAluno = &EEE;
	ponteiroPessoa = static_cast<Pessoa*>(ponteiroAluno);
	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());
}

void Principal::InicializaEstagiarios ( )
{
	Pessoa*		ponteiroPessoa;
	Aluno*		ponteiroAluno;
	Estagiario*	ponteiroEstagiario;

	// ************************************
    Fulano.setNome	("Fulano");
	Fulano.setBolsaEstudo (800);
	ponteiroEstagiario	= &Fulano;

	ponteiroAluno  = static_cast<Aluno*>(ponteiroEstagiario);
	LAlunos.incluaInfo(ponteiroAluno, ponteiroAluno->getNome());

	ponteiroPessoa = static_cast<Pessoa*>(ponteiroAluno);
	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());\

	// ************************************
    Ciclano.setNome	("Ciclano");
	Ciclano.setBolsaEstudo(801);
	ponteiroEstagiario	= &Ciclano;

	ponteiroAluno  = static_cast<Aluno*>(ponteiroEstagiario);
	LAlunos.incluaInfo(ponteiroAluno, ponteiroAluno->getNome());

	ponteiroPessoa = static_cast<Pessoa*>(ponteiroAluno);
	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());

}

void Principal::InicializaUnivesidades ( )
{  
    // Registro do(s) nome(s) da(s) universidade(s)
    UTFPR.setNome     ( "UTFPR"		);
	LUniversidades.incluaInfo( &UTFPR, UTFPR.getNome() );

    Princeton.setNome ( "Princeton" );
	LUniversidades.incluaInfo( &Princeton, Princeton.getNome() );

    Cambridge.setNome ( "Cambridge" );
	LUniversidades.incluaInfo( &Cambridge, Cambridge.getNome() );
}

void Principal::InicializaDepartamentos ( )
{ 
    // Registro do(s) nome(s) do(s) departamento(s)
    EletronicaUTFPR.setNome		( "Eletronica UTFPR" );
	MatematicaUTFPR.setNome		( "Matematica UTFPR" );
    FisicaUTFPR.setNome			( "Fisica UTFPR" );
    MatematicaPrinceton.setNome ( "Matematica Princeton" );
    FisicaPrinceton.setNome		( "Fisica Pirnceton" );
    MatematicaCambridge.setNome ( "Matematica Cambridge" );
    FisicaCambridge.setNome		( "Fisica Cambridge" );   

	LDepartamentos.incluaInfo(&EletronicaUTFPR, EletronicaUTFPR.getNome());
	LDepartamentos.incluaInfo(&MatematicaUTFPR, MatematicaUTFPR.getNome());
	LDepartamentos.incluaInfo(&FisicaUTFPR, FisicaUTFPR.getNome());
	LDepartamentos.incluaInfo(&MatematicaPrinceton, MatematicaPrinceton.getNome());
	LDepartamentos.incluaInfo(&FisicaPrinceton, FisicaPrinceton.getNome());
	LDepartamentos.incluaInfo(&MatematicaCambridge, MatematicaCambridge.getNome());
	LDepartamentos.incluaInfo(&FisicaCambridge, FisicaCambridge.getNome());
     
    // "Agregao" do(s) Departamento(s) a(s) Universidade(s).
    UTFPR.incluaDepartamento		( &EletronicaUTFPR );
    UTFPR.incluaDepartamento		( &MatematicaUTFPR );
    UTFPR.incluaDepartamento		( &FisicaUTFPR );

    Princeton.incluaDepartamento	( &MatematicaPrinceton );
    Princeton.incluaDepartamento	( &FisicaPrinceton );
    Cambridge.incluaDepartamento	( &MatematicaCambridge );
    Cambridge.incluaDepartamento	( &FisicaCambridge );
}

void Principal::InicializaProfessores ( )
{   
	Pessoa*		ponteiroPessoa;
	Professor*  ponteiroProfessor;

    // Inicializao do(s) ojeto(s) da classe Professor
    Simao.Inicializa	( 3, 10, 1976, "Jean Simo" );
	Einstein.Inicializa ( 14, 3, 1879, "Albert Einstein" );
    Newton.Inicializa	( 4, 1, 1643, "Isaac Newton" );

	Simao.setBolsaProjeto(1000);
	Simao.setSalario(4000);

	Einstein.setSalario(25000);
	Newton.setSalario(25000);
	 
    // "Filiao" a universidade.
    Simao.setUnivFiliado	( &UTFPR );
    Einstein.setUnivFiliado ( &Princeton );
    Newton.setUnivFiliado	( &Cambridge );

    // Area de Conhecimento.
    // Simao.setDominio		( "Computao );
    // Einstein.setDominio	( "Fsica" );
    // Newton.setDominio	( "Matemtica-Fsica" );

    // "Filiao" ao departamento.
    Simao.setDepartamento	( &EletronicaUTFPR );
    Einstein.setDepartamento( &FisicaPrinceton );
    Newton.setDepartamento	( &MatematicaCambridge );

	ponteiroProfessor = &Simao;
    ponteiroPessoa = static_cast<Pessoa*>(ponteiroProfessor);
	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());

	ponteiroProfessor = &Einstein;
    ponteiroPessoa = static_cast<Pessoa*>(ponteiroProfessor);
	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());

	ponteiroProfessor = &Newton;
    ponteiroPessoa = static_cast<Pessoa*>(ponteiroProfessor);
	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());
 }

void Principal::InicializaDisciplinas ( )
{
    Computacao1_2006.setNome	( "Computacao I 2006" );
    Introd_Alg_2007.setNome		( "Introducao de Algoritmos de Programacao 2007" );
	Computacao2_2007.setNome	( "Computao II" );
	Metodos2_2007.setNome		( "Mtodos II" );

	LDisciplinas.incluaInfo (&Computacao1_2006, Computacao1_2006.getNome());
	LDisciplinas.incluaInfo (&Introd_Alg_2007, Introd_Alg_2007.getNome());
	LDisciplinas.incluaInfo (&Computacao2_2007, Computacao2_2007.getNome());
	LDisciplinas.incluaInfo (&Metodos2_2007, Metodos2_2007.getNome());

    Computacao1_2006.setDepartamento  ( &EletronicaUTFPR );
    Introd_Alg_2007.setDepartamento	  ( &EletronicaUTFPR );
    Computacao2_2007.setDepartamento  ( &EletronicaUTFPR );
    Metodos2_2007.setDepartamento     ( &EletronicaUTFPR );

    Metodos2_2007.incluaAluno ( &AAA );
    Metodos2_2007.incluaAluno ( &BBB );
    Metodos2_2007.incluaAluno ( &CCC );
    Metodos2_2007.incluaAluno ( &DDD );
    Metodos2_2007.incluaAluno ( &EEE );

	Computacao2_2007.incluaAluno ( &AAA );
    Computacao2_2007.incluaAluno ( &EEE );
    Computacao2_2007.incluaAluno ( &DDD );
}

void Principal::CalcIdadeProfs ( )
{
    // Clculo da idade.
    Simao.Calc_Idade    ( diaAtual, mesAtual, anoAtual );
    Einstein.Calc_Idade ( diaAtual, mesAtual, anoAtual );
    Newton.Calc_Idade	( diaAtual, mesAtual, anoAtual );
    printf ("\n");
}

void Principal::UnivOndeProfsTrabalham ( )
{
    // Universidade que a Pessoa trabalha.
    Simao.OndeTrabalho ( );
    Einstein.OndeTrabalho ( );
    Newton.OndeTrabalho ( );
    
	cout << endl;
}

void Principal::DepOndeProfsTrabalham ( )
{
    // Departamento que a Pessoa trabalha.
    Simao.QualDepartamentoTrabalho ( );
    Einstein.QualDepartamentoTrabalho ( );
    Newton.QualDepartamentoTrabalho ( );
    //printf ( "\n" );
	cout << endl;
}

void Principal::ListeDiscDeptos()
{
    EletronicaUTFPR.listeDisciplinas();
 	cout << endl;
}

void Principal::ListeAlunosDisc()
{
    Metodos2_2007.listeAlunos();
    cout << endl;

    Computacao2_2007.listeAlunos();  
    cout << endl;

	//Metodos2_2007.listeAlunos2();
    //cout << endl;
}

void Principal::ListeProventosPessoas()
{
	Elemento<Pessoa>*	ponteiroElementoPessoa;
	Pessoa*				ponteiroPessoa;

	ponteiroElementoPessoa  = LPessoas.getPrimeiro();

	while ( ponteiroElementoPessoa != NULL )
	{
		ponteiroPessoa = ponteiroElementoPessoa->getInfo();

		ponteiroPessoa->informaProventos();

		ponteiroElementoPessoa = ponteiroElementoPessoa->getProximo();
	}
}

void Principal::Executar()
{
    //CalcIdadeProfs();
    //UnivOndeProfsTrabalham();
    //DepOndeProfsTrabalham();
	//ListeDiscDeptos();
    //ListeAlunosDisc();
	Menu();
}

void Principal::CadDisciplina()
{
	

}

void Principal::CadDepartamento()
{
    char nomeUniversidade[150];
	char nomeDepartamento[150];
	Universidade* univ;
	Departamento* depart;

	cout << "Qual o nome da universidade do departamento" << endl;
	cin  >> nomeUniversidade;

	univ = LUniversidades.localizar(nomeUniversidade);
	
	if ( univ != NULL )
	{
		cout << "Qual o nome do departamento" << endl;
		cin >> nomeDepartamento;
	    depart = new Departamento(cont_idDepart);
		cont_idDepart++;
		depart->setNome(nomeDepartamento);
		LDepartamentos.incluaInfo(depart, depart->getNome());
	}
	else
	{
		cout << "Universidade inexistente." << endl;
	}
}

void Principal::CadUniversidade()
{
    char nomeUniversidade[150];
	Universidade* univ;

	cout << "Qual o nome da universidade" << endl;
	cin  >> nomeUniversidade;

    univ = new Universidade();
	univ->setNome(nomeUniversidade);

	LUniversidades.incluaInfo(univ, univ->getNome());
}

void Principal::CadAluno()
{
    char	nomeAluno[150];
	int		ra;
	Aluno*	ponteiroAluno;
	Pessoa* ponteiroPessoa;

	cout << "Qual o nome do aluno. " << endl;
	cin  >> nomeAluno;

	cout << "Qual o RA do aluno."	<< endl;
	cin  >> ra;

    ponteiroAluno = new Aluno(cont_idAluno++);
	ponteiroAluno->setNome(nomeAluno);
	ponteiroAluno->setRA(ra);

	LAlunos.incluaInfo(ponteiroAluno, ponteiroAluno->getNome());

	// Logo abaixo a forma moderna de fazer cast
	ponteiroPessoa = static_cast<Pessoa*>(ponteiroAluno);

	// Logo abaixo a forma antiga e desaconselhavel de fazer cast
	//ponteiroPessoa = (Pessoa*)ponteiroAluno;     

	LPessoas.incluaInfo(ponteiroPessoa, ponteiroPessoa->getNome());
}

void Principal::GravarTudo()
{
}

void Principal::GravarUniversidades()
{
}

void Principal::GravarDepartamentos()
{
}

void Principal::GravarDisciplinas()
{
}

void Principal::GravarAlunos()
{
//	LAlunos.graveAlunos();
}

void Principal::GravarProfessores()
{
}

void Principal::RecuperarTudo()
{
}

void Principal::RecuperarUniversidades()
{
}

void Principal::RecuperarDepartamentos()
{
}

void Principal::RecuperarDisciplinas()
{
}

void Principal::RecuperarAlunos()
{
	//LAlunos.recupereAlunos();
}

void Principal::RecuperarProfessores()
{
}

void Principal::MenuCad()
{
    int op = -1;

    while (op != 5)
    {
		system("cls");
        cout << "  Informe sua opo:			"	<< endl;
        cout << "  1 - Cadastrar Disciplina.	"	<< endl;
        cout << "  2 - Cadastrar Departamentos. "	<< endl;
        cout << "  3 - Cadastrar Universidade.	"	<< endl;
		cout << "  4 - Cadastrar Aluno.			"	<< endl;
        cout << "  5  Sair. "						<< endl;
        cin >> op;

        switch (op)
        {
            case 1 :{ CadDisciplina ();	 }
                break;

            case 2: { CadDepartamento(); }
				break;

			case 3:	{ CadUniversidade(); }
				break;

			case 4:	{ CadAluno(); }
				break;

            case 5:	{ cout << " FIM " << endl; }
                break;

            default:{                      
					  cout << "Opo Invlida - Pressione uma tecla." << endl;
					  getchar();
				    }
        }
    }
}

void Principal::MenuExe()
{
    int op = -1;
    while ( op != 8 )
    {
		system("cls");
        cout << "  Informe sua opo:		"	<< endl;
        cout << "  1 - Listar Disciplinas.  "	<< endl;
        cout << "  2 - Listar Departamentos."	<< endl;
        cout << "  3 - Listar Universidade. "	<< endl;
		cout << "  4 - Listar Alunos. "			<< endl;
		cout << "  5 - Listar Professores."		<< endl;
		cout << "  6 - Listar Pessoas."			<< endl;
		cout << "  7 - Listar Proventos."		<< endl;
        cout << "  8  Sair. "					<< endl;
        cin  >> op;

        switch ( op )
        {
			case 1:  { 
					   LDisciplinas.listeInfos();
					   system ("Pause");	
					 }
                break;
			case 2:  { 
				       LDepartamentos.listeInfos();
					   system ("Pause");
					 }
				break;
			case 3:  { 
				       LUniversidades.listeInfos(); 
				       system ("Pause");
					 }
				break;
			case 4:  { 
					   LAlunos.listeInfos(); 
				       system ("Pause");
					 }
                break;
	        case 5:  { 
						DepOndeProfsTrabalham(); 
						system ("Pause");
					 }
                break; 
            case 6:  { 
						LPessoas.listeInfos();
						system ("Pause");
					 }
                break;
			case 7:  { 
						ListeProventosPessoas(); 
						system ("Pause");
					 }
                break;
			case 8:  { 
						cout << " FIM " << endl; 
					 }
                break;
            default: { 
					   cout << "Opo Invlida - Pressione uma tecla." << endl;
					   getchar(); 
					 }
        }
    }
}

void Principal::MenuGravar()
{
	int op = -1; 
    while (op != 6)
    {
		system("cls");
        cout << "  Informe sua opo:			"	<< endl;
		cout << "  0 - Gravar Tudo.				"	<< endl;
        cout << "  1 - Gravar Universidades.	"	<< endl;
        cout << "  2 - Gravar Departamentos.	"	<< endl;
		cout << "  3 - Gravar Disciplinas.		"	<< endl;
		cout << "  4 - Gravar Alunos.			"	<< endl;
		cout << "  5 - Gravar Professores.		"	<< endl;
        cout << "  6  Sair.					"	<< endl;
        cin >> op;

        switch (op)
        {
			case 0: {	GravarTudo();			 }
                break;
            case 1: {	GravarUniversidades();	 }
                break;
            case 2: {	GravarDepartamentos();	 }
				break;
			case 3: {	GravarDisciplinas();	 }
				break;
			case 4: {	GravarAlunos();			 }
				break;
			case 5: {	GravarProfessores();	 }
				break;
			case 6: {	cout << " FIM " << endl; }
                break;
            default: { cout << "Opo Invlida - Pressione uma tecla." << endl;
					   getchar(); }
        }
    }	
}

void Principal::MenuRecuperar()
{
	int op = -1;
    
    while (op != 6)
    {
		system("cls");

        cout << "  Informe sua opo:			"	<< endl;
		cout << "  0 - Recuperar Tudo.			"	<< endl;
        cout << "  1 - Recuperar Universidades.	"	<< endl;
        cout << "  2 - Recuperar Departamentos.	"	<< endl;
		cout << "  3 - Recuperar Disciplinas.	"	<< endl;
		cout << "  4 - Recuperar Alunos.		"	<< endl;
		cout << "  5 - Recuperar Professores.	"	<< endl;
        cout << "  6  Sair.					"	<< endl;
        cin >> op;

        switch (op)
        {
			case 0: {	RecuperarTudo();			 }
                break;
            case 1: {	RecuperarUniversidades();	 }
                break;
            case 2: {	RecuperarDepartamentos();	 }
				break;
			case 3: {	RecuperarDisciplinas();	 }
				break;
			case 4: {	RecuperarAlunos();			 }
				break;
			case 5: {	RecuperarProfessores();	 }
				break;
			case 6: {	cout << " FIM " << endl; }
                break;
            default: { cout << "Opo Invlida - Pressione uma tecla." << endl;
					   getchar(); }
        }
    }	
}

void Principal::Menu()
{
	int op = -1;
    while (op != 5)
    {
		system("cls");
        cout << "  Informe sua opo:"	<< endl;
        cout << "  1 - Cadastrar.	 "	<< endl;
        cout << "  2 - Executar.	 "	<< endl;
		cout << "  3 - Gravar.		 "  << endl;
		cout << "  4 - Recuperar.	 "  << endl;
        cout << "  5  Sair.		 "	<< endl;
        cin >> op;

        switch (op)
        {
            case 1: {	MenuCad();			}
                break;
            case 2: {	MenuExe();			}
				break;
			case 3: {	MenuGravar();		}
				break;
			case 4: {	MenuRecuperar();	}
				break;
			case 5: {	cout << " FIM " << endl; }
                break;
            default: { cout << "Opo Invlida - Pressione uma tecla." << endl;
					   getchar(); }
        }
    }	
}
