#include "stdafx.h"
#include "Departamento.h"
#include "Universidade.h"

#include "Disciplina.h"

Departamento::Departamento(int i)
{
	pUniv = NULL;
	id = i;
	pObjLDisciplinas = new Lista<Disciplina>();
}

Departamento::~Departamento()
{
	if (pObjLDisciplinas)
	{
		delete pObjLDisciplinas;
	}
	pUniv = NULL;
}

int Departamento::getId()
{
	return id;
}

void Departamento::setNome(char* n)
{
    strcpy(nome, n);
	//ObjLDisciplinas->setNome(n);
}

char* Departamento::getNome()
{
    return nome;
}


void Departamento::setUniversidade ( Universidade* pu )
{
   pUniv = pu;
}

Universidade* Departamento::getUniversidade ( )
{
   return pUniv;
}

void Departamento::incluaDisciplina ( Disciplina* pd )
{  
	pObjLDisciplinas->incluaInfo (pd);
}

void Departamento::listeDisciplinas ( )
{
    pObjLDisciplinas->listeInfos();
}

void Departamento::listeDisciplinas2 ( )
{
    //ObjLDisciplinas->listeDisciplinas2();
}

