
#ifndef _DEPARTAMENTO_H_
#define _DEPARTAMENTO_H_

class Universidade;
class Disciplina;

template<class TIPO>
class Lista;
      
class Departamento
{
  private:
     int id;
     char nome[130];

     // Associao para com uma Universidade.
     Universidade* pUniv;
     // Associao para com vrias Disciplinas.
     Lista<Disciplina>* pObjLDisciplinas;

  public:
     Departamento(int i);
     ~Departamento();

	 int getId();

     void setNome(char* n);
     char* getNome();

     void setUniversidade(Universidade* pu);
     Universidade* getUniversidade();

     void incluaDisciplina ( Disciplina* pd );
     void listeDisciplinas();
     void listeDisciplinas2();
};

#endif

