#ifndef _DISCIPLINA_H_
#define _DISCIPLINA_H_

#include "Aluno.h"
#include "Departamento.h"
#include "Lista.h"

class Disciplina
{ 
private:
    int id;
    char nome[150];
    char area_conhecimento[150];
     
    Departamento* pDeptoAssociado; 
    Lista<Aluno> ObjLAlunos;

  public:
    Disciplina(int i, int na = 45, char* ac = "");
    ~Disciplina();

    void setId(int i);
	int getId();

	void setNome(char* n);
	char* getNome();
	
	void setDepartamento(Departamento* pd);
	Departamento* getDepartamento();

    void incluaAluno(Aluno* pa);
    void listeAlunos();
    void listeAlunos2();
};

#endif
